diff --git a/fs/file.c b/fs/file.c
index 0be3447..966bf0c 100644
--- a/fs/file.c
+++ b/fs/file.c
@@ -43,9 +43,11 @@ static inline void *alloc_fdmem(unsigned int size)
 {
 	void *data;
 
-	data = kmalloc(size, GFP_KERNEL|__GFP_NOWARN);
-	if (data != NULL)
-		return data;
+	if (size <= PAGE_SIZE) {
+		data = kmalloc(size, GFP_KERNEL|__GFP_NOWARN);
+		if (data != NULL)
+			return data;
+	}
 
 	return vmalloc(size);
 }
